;============================================
; Paltest -- palindrome test bed
;
; LESSONS LEARNED IN THIS CODE:
;-------------------------------
; o Subclassing windows (edit control)
; o Handling keyboard input, looking for
;   "control" chars (like backspace)
;============================================


.386
.model flat, stdcall
option casemap :none

.nolist
	include \masm32\include\windows.inc
	include \masm32\include\user32.inc
	include \masm32\include\kernel32.inc
	include \masm32\include\gdi32.inc
	include \masm32\include\comctl32.inc

	includelib \masm32\lib\gdi32.lib
	includelib \masm32\lib\user32.lib
	includelib \masm32\lib\kernel32.lib
	includelib \masm32\lib\Comctl32.lib
	includelib \masm32\lib\comdlg32.lib
	includelib \masm32\lib\shell32.lib
	includelib \masm32\lib\oleaut32.lib
	includelib \masm32\lib\ole32.lib
	includelib \masm32\lib\msvcrt.lib
.list


;============================================
; Defines, macros, prototypes, etc.
;============================================

WinMain			PROTO :DWORD
AddCharacter		PROTO char:DWORD
EditProc		PROTO hWin:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD


$mainWinWidth		EQU 700
$mainWinHeight		EQU 90

$editID			EQU 2100
$editX			EQU 20
$editY			EQU 50
$editWidth		EQU 600
$editHeight		EQU 20

$backspace		EQU 8


;===== Window styles: =====
$mainWinAttrs		EQU WS_OVERLAPPEDWINDOW OR WS_CLIPCHILDREN
$editStyles		EQU ES_CENTER OR WS_VISIBLE OR WS_CHILD

;===== Window background colors: =====
$bkRED			EQU 254
$bkGRN			EQU 243
$bkBLUE			EQU 199

$BkColor		EQU $bkRED OR ($bkGRN SHL 8) OR ($bkBLUE SHL 16)
$starkWhite		EQU 0FFFFFFH


;============================================
; DATA
;============================================
.data

InstanceHandle		HWND ?
MainWinHandle		HWND ?
EditHandle		HWND ?

OldEditProcPtr		DD ?

CharCount		DD 0
InsertOffset		DD 0


PalBuffer		DB 400 DUP(?)

MainClassName		DB "palindrome", 0
EditClassName		DB "edit", 0

MainTitleText		DB "Palindrome Tester", 0

heremsg			DB "I are here", 0


;============================================
; CODE
;============================================
.code


start:
	INVOKE	GetModuleHandle, NULL
	MOV	InstanceHandle, EAX

	INVOKE	WinMain, InstanceHandle
	INVOKE	ExitProcess, EAX


;====================================================================
; Mainline proc
;====================================================================

WinMain	PROC hInst:DWORD
	LOCAL	wc:WNDCLASSEX, msg:MSG, brush:HBRUSH, wX:DWORD, wY:DWORD


; Create  brush to set background color:
	INVOKE	CreateSolidBrush, $BkColor
	MOV	brush, EAX

; Register class for parent window:
	MOV	wc.cbSize, SIZEOF WNDCLASSEX
	MOV	wc.style,  CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW
	MOV	wc.lpfnWndProc, OFFSET MainWindowProc
	MOV	wc.cbClsExtra, NULL
	MOV	wc.cbWndExtra, NULL
	MOV	EAX, hInst
	MOV	wc.hInstance, EAX
	MOV	EAX, brush
	MOV	wc.hbrBackground, EAX
	MOV	wc.lpszMenuName,  NULL
	MOV	wc.lpszClassName, OFFSET MainClassName
	MOV	wc.hIcon, NULL
	INVOKE	LoadCursor, NULL, IDC_ARROW
	MOV	wc.hCursor, EAX
	MOV	wc.hIconSm, 0
	INVOKE	RegisterClassEx, ADDR wc

	INVOKE	CreateSolidBrush, $starkWhite
	MOV	brush, EAX

	INVOKE	GetSystemMetrics, SM_CXSCREEN
	MOV	EDX, $mainWinWidth
	CALL	CenterDim
	MOV	wX, EAX
	INVOKE	GetSystemMetrics, SM_CYSCREEN
	MOV	EDX, $mainWinHeight
	CALL	CenterDim
	MOV	wY, EAX

; Create our main window:
	INVOKE	CreateWindowEx, WS_EX_OVERLAPPEDWINDOW, ADDR MainClassName, ADDR MainTitleText,
		$mainWinAttrs, wX, wY, $mainWinWidth, $mainWinHeight,
		NULL, NULL, hInst, NULL
	MOV	MainWinHandle, EAX
	INVOKE	ShowWindow, EAX, SW_SHOWNORMAL

	MOV	EAX, $mainWinWidth
	MOV	EDX, $editWidth
	CALL	CenterDim
	MOV	wX, EAX
	MOV	EAX, $mainWinHeight - 20		;Take out something for title bar.
	MOV	EDX, $editHeight
	CALL	CenterDim
	MOV	wY, EAX

; Create edit control:
	INVOKE	CreateWindowEx, WS_EX_LEFT OR WS_EX_CLIENTEDGE, ADDR EditClassName, NULL,
		$editStyles, wX, wY,
		$editWidth, $editHeight, MainWinHandle, $editID, InstanceHandle, NULL
	MOV	EditHandle, EAX

; Subclass the edit control:
	INVOKE	SetWindowLong, EditHandle, GWL_WNDPROC, ADDR EditProc
	MOV	OldEditProcPtr, EAX


;============= Message loop ===================
msgloop:
	INVOKE	GetMessage, ADDR msg, NULL, 0, 0
	OR	EAX, EAX				;EAX = 0 = exit
	JZ	exit
	INVOKE	TranslateMessage, ADDR msg
	INVOKE	DispatchMessage, ADDR msg
	JMP	msgloop

exit:	MOV	EAX, msg.wParam
	RET

WinMain		ENDP


;====================================================================
; Main window Proc
;====================================================================

MainWindowProc	PROC hWin:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD

	MOV	EAX, uMsg
	CMP	EAX, WM_CLOSE
	JE	doclose

dodefault:
; use DefWindowProc for all other messages:
	INVOKE	DefWindowProc, hWin, uMsg, wParam, lParam
	RET

doclose:
	INVOKE	PostQuitMessage, NULL
	MOV	EAX, TRUE
	RET

MainWindowProc	ENDP


;====================================================================
; Edit window Proc
;
; (Subclassed from edit control class)
;====================================================================

EditProc	PROC hWin:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD

	MOV	EAX, uMsg
	CMP	EAX, WM_CHAR
	JE	dochar

; use old window proc for all other messages:
	INVOKE	CallWindowProc, OldEditProcPtr, hWin, uMsg, wParam, lParam
	RET

dochar:
	MOV	EAX, wParam
	CMP	EAX, $backspace
	JE	do_bksp
	INVOKE	AddCharacter, EAX
pc40:	INVOKE	SendMessage, EditHandle, WM_SETTEXT, 0, ADDR PalBuffer
	MOV	EAX, CharCount
	SHR	EAX, 1
	INVOKE	SendMessage, EditHandle, EM_SETSEL, EAX, EAX
	XOR	EAX, EAX
	RET

do_bksp:
	CALL	RemoveCharacter
	JMP	pc40

EditProc	ENDP



AddCharacter	PROC	newChar:DWORD

	PUSH	EBX
	LEA	EBX, PalBuffer
	MOV	ECX, CharCount
	JCXZ	ic20
	ADD	EBX, ECX			;EBX = dest
	INC	EBX
	SHR	ECX, 1				;Move count = # chars/2
; Move chars starting @ end:
mvloop:	MOV	AL, BYTE PTR [EBX - 2]
	MOV	BYTE PTR [EBX], AL		;Move forwards
	DEC	EBX				; move move pt. backwards
	LOOP	mvloop
	DEC	EBX				;Back up 1 more (2 chars to put in).
ic20:	MOV	AL, BYTE PTR newChar
	MOV	BYTE PTR [EBX], AL
	MOV	BYTE PTR [EBX + 1], AL
	ADD	CharCount, 2
	LEA	EBX, PalBuffer
	ADD	EBX, CharCount
	MOV	BYTE PTR [EBX], 0
	POP	EBX
	RET

AddCharacter	ENDP


RemoveCharacter	PROC

	PUSH	EBX
	MOV	ECX, CharCount
	JCXZ	rc99				;If zero count, do nothing.
	SHR	ECX, 1
	DEC	ECX
	JNZ	rc10				;If count = 2, do something special.
	MOV	CharCount, 0
	LEA	EBX, PalBuffer
	JMP	SHORT rc70
	
rc10:	LEA	EBX, PalBuffer
	ADD	EBX, ECX
rcloop:	MOV	AL, BYTE PTR [EBX + 2]
	MOV	BYTE PTR [EBX], AL
	INC	EBX
	LOOP	rcloop
	SUB	CharCount, 2
	LEA	EBX, PalBuffer
	ADD	EBX, CharCount
rc70:	MOV	BYTE PTR [EBX], 0
rc99:	POP	EBX
	RET

RemoveCharacter	ENDP



;====================================================================
; CenterDim
;
; Returns half screen dimension (X or Y) minus half window dimension
;
; On entry,
;	EAX = screen dimension
;	EDX = window dimension
;
; Returns:
;	sdim/2 - wdim/2
;====================================================================

CenterDim	PROC

	SHR	EAX, 1				;divide screen dimension by 2
	SHR	EDX, 1				;divide window dimension by 2
	SUB	EAX, EDX
	RET					;Return w/# in EAX

CenterDim	ENDP


	END	start



